from shapely.geometry import Polygon, Point

TTK = [
    [55.7048, 37.6302], [55.7033, 37.6546], [55.7115, 37.6721], [55.7126, 37.6755], [55.7136, 37.6786],
    [55.7148, 37.6820], [55.7155, 37.6851], [55.7169, 37.6889], [55.7177, 37.6934], [55.7188, 37.6968],
    [55.7200, 37.6999], [55.7211, 37.7043], [55.7225, 37.7085], [55.7241, 37.7109], [55.7256, 37.7112],
    [55.7273, 37.7095], [55.7293, 37.7067], [55.7310, 37.7050], [55.7326, 37.7026], [55.7343, 37.7009],
    [55.7363, 37.6992], [55.7380, 37.6975], [55.7399, 37.6975], [55.7417, 37.6975], [55.7432, 37.6982],
    [55.7450, 37.6989], [55.7475, 37.6992], [55.7502, 37.6971], [55.7518, 37.6961], [55.7541, 37.6937],
    [55.7556, 37.6920], [55.7578, 37.6923], [55.7601, 37.6923], [55.7622, 37.6923], [55.7641, 37.6923],
    [55.7663, 37.6923], [55.7680, 37.6923], [55.7699, 37.6910], [55.7717, 37.6882], [55.7736, 37.6851],
    [55.7756, 37.6824], [55.7773, 37.6789], [55.7787, 37.6755], [55.7798, 37.6728], [55.7819, 37.6693],
    [55.7833, 37.6662], [55.7856, 37.6635], [55.7881, 37.6594], [55.7903, 37.6573], [55.7922, 37.6546],
    [55.7936, 37.6515], [55.7939, 37.6463], [55.7934, 37.6429], [55.7928, 37.6395], [55.7922, 37.6353],
    [55.7924, 37.6305], [55.7928, 37.6254], [55.7928, 37.6213], [55.7932, 37.6165], [55.7932, 37.6127],
    [55.7932, 37.6072], [55.7930, 37.6017], [55.7926, 37.5989], [55.7926, 37.5945], [55.7924, 37.5904],
    [55.7922, 37.5856], [55.7922, 37.5797], [55.7918, 37.5753], [55.7907, 37.5725], [55.7887, 37.5698],
    [55.7874, 37.5680], [55.7858, 37.5656], [55.7843, 37.5636], [55.7823, 37.5615], [55.7802, 37.5584],
    [55.7787, 37.5567], [55.7773, 37.5550], [55.7759, 37.5543], [55.7748, 37.5526], [55.7740, 37.5478],
    [55.7730, 37.5447], [55.7713, 37.5433], [55.7696, 37.5416], [55.7682, 37.5392], [55.7667, 37.5371],
    [55.7645, 37.5358], [55.7624, 37.5351], [55.7599, 37.5337], [55.7579, 37.5334], [55.7562, 37.5327],
    [55.7539, 37.5320], [55.7518, 37.5317], [55.7494, 37.5317], [55.7465, 37.5323], [55.7446, 37.5334],
    [55.7425, 37.5334], [55.7409, 37.5344], [55.7384, 37.5365], [55.7366, 37.5392], [55.7351, 37.5413],
    [55.7337, 37.5437], [55.7324, 37.5444], [55.7308, 37.5450], [55.7295, 37.5464], [55.7281, 37.5468],
    [55.7266, 37.5485], [55.7246, 37.5499], [55.7235, 37.5529], [55.7219, 37.5550], [55.7211, 37.5581],
    [55.7206, 37.5605], [55.7196, 37.5636], [55.7188, 37.5670], [55.7179, 37.5704], [55.7163, 37.5725],
    [55.7151, 37.5753], [55.7138, 37.5773], [55.7124, 37.5794], [55.7111, 37.5811], [55.7095, 37.5835],
    [55.7082, 37.5856], [55.7070, 37.5890], [55.7060, 37.5917], [55.7053, 37.5941], [55.7043, 37.5972],
    [55.7037, 37.6000], [55.7023, 37.6034], [55.7014, 37.6065], [55.7010, 37.6113], [55.7014, 37.6147],
    [55.7047, 37.6310], [55.7029, 37.6528], [55.7099, 37.6697], [55.7085, 37.6669], [55.7068, 37.6642],
    [55.7054, 37.6611], [55.7039, 37.6580], [55.7035, 37.6542], [55.7035, 37.6494], [55.7039, 37.6425],
    [55.7041, 37.6384], [55.7045, 37.6350], [55.7049, 37.6298], [55.7037, 37.6250], [55.7029, 37.6206],
    [55.7016, 37.6144], [55.7048, 37.6302]
]

MKAD = [
    [55.774558, 37.842762], [55.76522, 37.842789], [55.755723, 37.842627], [55.747399, 37.841828],
    [55.739103, 37.841217], [55.730482, 37.840175], [55.721939, 37.83916], [55.712203, 37.837121],
    [55.703048, 37.83262], [55.694287, 37.829512], [55.68529, 37.831353], [55.675945, 37.834605],
    [55.667752, 37.837597], [55.658667, 37.839348], [55.650053, 37.833842], [55.643713, 37.824787],
    [55.637347, 37.814564], [55.62913, 37.802473], [55.623758, 37.794235], [55.617713, 37.781928],
    [55.611755, 37.771139], [55.604956, 37.758725], [55.599677, 37.747945], [55.594143, 37.734785],
    [55.589234, 37.723062], [55.583983, 37.709425], [55.578834, 37.696256], [55.574019, 37.683167],
    [55.571999, 37.668911], [55.573093, 37.647765], [55.573928, 37.633419], [55.574732, 37.616719],
    [55.575816, 37.60107], [55.5778, 37.586536], [55.581271, 37.571938], [55.585143, 37.555732],
    [55.587509, 37.545132], [55.5922, 37.526366], [55.594728, 37.516108], [55.60249, 37.502274],
    [55.609685, 37.49391], [55.617424, 37.484846], [55.625801, 37.474668], [55.630207, 37.469925],
    [55.641041, 37.456864], [55.648794, 37.448195], [55.654675, 37.441125], [55.660424, 37.434424],
    [55.670701, 37.42598], [55.67994, 37.418712], [55.686873, 37.414868], [55.695697, 37.407528],
    [55.702805, 37.397952], [55.709657, 37.388969], [55.718273, 37.383283], [55.728581, 37.378369],
    [55.735201, 37.374991], [55.744789, 37.370248], [55.75435, 37.369188], [55.762936, 37.369053],
    [55.771444, 37.369619], [55.779722, 37.369853], [55.789542, 37.372943], [55.79723, 37.379824],
    [55.805796, 37.386876], [55.814629, 37.390397], [55.823606, 37.393236], [55.83251, 37.395275],
    [55.840376, 37.394709], [55.850141, 37.393056], [55.858801, 37.397314], [55.867051, 37.405588],
    [55.872703, 37.416601], [55.877041, 37.429429], [55.881091, 37.443596], [55.882828, 37.459065],
    [55.884625, 37.473096], [55.888897, 37.48861], [55.894232, 37.5016], [55.899578, 37.513206],
    [55.90526, 37.527597], [55.907687, 37.543443], [55.909388, 37.559577], [55.910907, 37.575531],
    [55.909257, 37.590344], [55.905472, 37.604637], [55.901637, 37.619603], [55.898533, 37.635961],
    [55.896973, 37.647648], [55.895449, 37.667878], [55.894868, 37.681721], [55.893884, 37.698807],
    [55.889094, 37.712363], [55.883555, 37.723636], [55.877501, 37.735791], [55.874698, 37.741261],
    [55.862464, 37.764519], [55.861979, 37.765992], [55.850257, 37.788216], [55.850383, 37.788522],
    [55.844167, 37.800586], [55.832707, 37.822819], [55.828789, 37.829754], [55.821072, 37.837148],
    [55.811599, 37.838926], [55.802781, 37.840004], [55.793991, 37.840965], [55.785017, 37.841576]
]

MMK = [
    [55.9298, 36.9637], [55.9264, 36.9637], [55.9318, 36.9582], [55.9395, 36.9665], [55.9549, 36.9747],
    [55.9749, 36.9912], [55.9841, 37.0104], [55.9995, 37.0214], [56.0119, 37.0297], [56.0257, 37.0461],
    [56.0318, 37.0654], [56.0380, 37.0846], [56.0441, 37.1093], [56.0534, 37.1340], [56.0672, 37.1395],
    [56.0826, 37.1368], [56.0902, 37.1560], [56.0979, 37.1725], [56.1071, 37.1890], [56.1148, 37.2137],
    [56.1163, 37.2411], [56.1194, 37.2631], [56.1194, 37.2823], [56.1225, 37.3098], [56.1240, 37.3345],
    [56.1301, 37.3592], [56.1332, 37.3785], [56.1363, 37.4032], [56.1363, 37.4307], [56.1378, 37.4581],
    [56.1378, 37.4773], [56.1424, 37.4938], [56.1608, 37.4911], [56.1731, 37.5048], [56.1915, 37.5213],
    [56.2037, 37.5295], [56.2006, 37.5515], [56.1930, 37.5762], [56.1884, 37.5982], [56.1838, 37.6147],
    [56.1792, 37.6366], [56.1746, 37.6614], [56.1685, 37.6943], [56.1608, 37.7245], [56.1562, 37.7520],
    [56.1547, 37.7822], [56.1501, 37.8069], [56.1439, 37.8399], [56.1363, 37.8701], [56.1301, 37.8921],
    [56.1255, 37.9168], [56.1163, 37.9498], [56.1025, 37.9635], [56.0902, 37.9964], [56.0841, 38.0239],
    [56.0780, 38.0486], [56.0733, 38.0679], [56.0672, 38.0981], [56.0611, 38.1146], [56.0564, 38.1338],
    [56.0503, 38.1530], [56.0457, 38.1695], [56.0411, 38.1942], [56.0334, 38.2134], [56.0257, 38.2354],
    [56.0134, 38.2601], [56.0026, 38.2821], [55.9965, 38.3041], [55.9903, 38.3315], [55.9764, 38.3480],
    [55.9641, 38.3617], [55.9503, 38.3837], [55.9379, 38.3974], [55.9256, 38.4002], [55.9071, 38.4057],
    [55.8917, 38.4249], [55.8747, 38.4359], [55.8592, 38.4359], [55.8484, 38.4277], [55.8360, 38.4249],
    [55.8237, 38.4249], [55.8113, 38.4332], [55.8005, 38.4332], [55.7881, 38.4304], [55.7757, 38.4332],
    [55.7649, 38.4386], [55.7494, 38.4524], [55.7339, 38.4634], [55.7277, 38.4304], [55.7122, 38.4277],
    [55.7029, 38.4359], [55.6936, 38.4194], [55.6796, 38.4084], [55.6672, 38.3920], [55.6548, 38.3810],
    [55.6408, 38.3727], [55.6237, 38.3672], [55.6051, 38.3700], [55.5926, 38.3837], [55.5786, 38.3837],
    [55.5662, 38.3947], [55.5506, 38.4002], [55.5397, 38.4002], [55.5226, 38.4002], [55.5070, 38.3865],
    [55.4914, 38.3672], [55.4789, 38.3453], [55.4680, 38.3398], [55.4571, 38.3288], [55.4446, 38.3123],
    [55.4258, 38.2931], [55.4165, 38.2601], [55.4071, 38.2299], [55.3977, 38.2107], [55.3883, 38.1915],
    [55.3805, 38.1667], [55.3758, 38.1420], [55.3727, 38.1200], [55.3711, 38.0898], [55.3680, 38.0514],
    [55.3649, 38.0184], [55.3664, 37.9827], [55.3680, 37.9607], [55.3602, 37.9360], [55.3539, 37.9113],
    [55.3461, 37.8838], [55.3414, 37.8481], [55.3383, 37.8152], [55.3351, 37.7850], [55.3320, 37.7547],
    [55.3320, 37.7190], [55.3320, 37.6751], [55.3320, 37.6366], [55.3336, 37.6009], [55.3336, 37.5680],
    [55.3336, 37.5323], [55.3351, 37.4993], [55.3398, 37.4746], [55.3492, 37.4471], [55.3633, 37.4307],
    [55.3727, 37.4059], [55.3821, 37.3785], [55.3899, 37.3510], [55.3915, 37.3263], [55.3946, 37.3016],
    [55.3962, 37.2714], [55.3977, 37.2356], [55.4087, 37.2137], [55.4180, 37.1917], [55.4290, 37.1697],
    [55.4399, 37.1478], [55.4477, 37.1175], [55.4617, 37.0983], [55.4711, 37.0736], [55.4820, 37.0516],
    [55.4929, 37.0297], [55.5070, 37.0104], [55.5148, 36.9939], [55.5319, 36.9802], [55.5475, 36.9885],
    [55.5615, 36.9885], [55.5739, 36.9967], [55.5880, 37.0049], [55.6066, 37.0077], [55.6284, 36.9994],
    [55.6408, 36.9802], [55.6610, 36.9665], [55.6734, 36.9500], [55.6750, 36.9253], [55.6843, 36.8978],
    [55.7044, 36.8813], [55.7215, 36.8731], [55.7354, 36.8786], [55.7509, 36.8868], [55.7695, 36.8978],
    [55.7804, 36.9170], [55.7989, 36.9225], [55.8206, 36.9170], [55.8391, 36.9225], [55.8577, 36.9335],
    [55.8762, 36.9418], [55.8901, 36.9363], [55.9025, 36.9445], [55.9148, 36.9692], [55.9298, 36.9637]
]

BMK = [
    [56.1105, 36.5548], [56.1695, 36.6056], [56.1772, 36.6194], [56.2139, 36.6358], [56.2415, 36.6633],
    [56.2782, 36.6798], [56.3118, 36.6963], [56.3423, 36.7402], [56.3697, 36.7787], [56.3789, 36.8281],
    [56.4033, 36.8666], [56.4033, 36.8995], [56.4154, 36.9325], [56.4246, 36.9709], [56.4246, 37.0149],
    [56.4154, 37.0533], [56.4246, 37.1028], [56.4398, 37.1467], [56.4307, 37.1907], [56.4185, 37.2291],
    [56.4063, 37.2621], [56.3941, 37.2950], [56.3789, 37.3445], [56.3758, 37.3829], [56.3728, 37.4269],
    [56.3636, 37.4708], [56.3575, 37.5093], [56.3667, 37.5642], [56.3850, 37.6081], [56.4033, 37.6411],
    [56.4185, 37.6905], [56.4185, 37.7290], [56.4246, 37.7729], [56.4337, 37.8169], [56.4367, 37.8608],
    [56.4428, 37.9048], [56.4307, 37.9487], [56.4215, 37.9872], [56.4093, 38.0201], [56.3941, 38.0531],
    [56.3819, 38.0860], [56.3728, 38.1245], [56.3728, 38.1574], [56.3636, 38.2014], [56.3453, 38.2398],
    [56.3301, 38.2838], [56.3148, 38.3277], [56.3026, 38.3662], [56.2904, 38.4046], [56.2751, 38.4376],
    [56.2476, 38.4596], [56.2323, 38.4925], [56.2139, 38.5200], [56.1925, 38.5420], [56.1741, 38.5584],
    [56.1557, 38.5749], [56.1343, 38.5969], [56.1189, 38.6354], [56.1005, 38.6628], [56.0790, 38.6958],
    [56.0514, 38.7232], [56.0298, 38.7452], [56.0083, 38.7727], [55.9837, 38.7837], [55.9559, 38.8001],
    [55.9374, 38.8001], [55.9097, 38.8276], [55.8850, 38.8496], [55.8696, 38.8825], [55.8696, 38.9375],
    [55.8479, 38.9649], [55.8263, 38.9704], [55.7984, 38.9704], [55.7768, 38.9594], [55.7582, 38.9485],
    [55.7365, 38.9485], [55.7117, 38.9540], [55.6931, 38.9540], [55.6683, 38.9485], [55.6341, 38.9320],
    [55.6061, 38.9320], [55.5750, 38.9100], [55.5501, 38.8935], [55.5283, 38.8825], [55.5003, 38.8825],
    [55.4784, 38.8771], [55.4566, 38.8496], [55.4378, 38.8276], [55.4160, 38.7947], [55.3941, 38.7672],
    [55.3753, 38.7397], [55.3503, 38.7178], [55.3284, 38.6738], [55.3221, 38.6189], [55.3096, 38.5804],
    [55.2939, 38.5255], [55.2751, 38.4925], [55.2626, 38.4486], [55.2375, 38.4321], [55.2218, 38.4101],
    [55.2061, 38.3717], [55.1841, 38.3332], [55.1652, 38.3277], [55.1463, 38.2893], [55.1369, 38.2508],
    [55.1243, 38.2124], [55.1149, 38.1684], [55.1023, 38.1190], [55.0960, 38.0805], [55.0960, 38.0366],
    [55.0865, 37.9927], [55.0802, 37.9487], [55.0802, 37.9048], [55.0739, 37.8443], [55.0707, 37.7949],
    [55.0550, 37.7510], [55.0424, 37.7070], [55.0424, 37.6631], [55.0424, 37.6081], [55.0392, 37.5477],
    [55.0298, 37.4873], [55.0298, 37.4433], [55.0045, 37.4214], [54.9792, 37.4214], [54.9761, 37.3774],
    [54.9856, 37.3280], [54.9982, 37.2730], [55.0108, 37.2126], [55.0329, 37.1687], [55.0424, 37.1083],
    [55.0518, 37.0643], [55.0644, 37.0259], [55.0707, 36.9874], [55.0928, 36.9435], [55.1023, 36.9050],
    [55.1180, 36.8720], [55.1212, 36.8226], [55.1400, 36.7732], [55.1558, 36.7237], [55.1683, 36.6853],
    [55.1904, 36.6358], [55.2123, 36.5974], [55.2375, 36.5589], [55.2626, 36.5150], [55.2877, 36.4985],
    [55.3159, 36.4656], [55.3440, 36.4381], [55.3691, 36.4051], [55.3941, 36.3886], [55.4222, 36.3557],
    [55.4566, 36.3557], [55.4815, 36.3612], [55.5065, 36.3557], [55.5377, 36.3722], [55.5626, 36.3886],
    [55.5875, 36.3722], [55.6186, 36.3447], [55.6372, 36.3172], [55.6558, 36.2788], [55.6683, 36.2568],
    [55.6838, 36.2184], [55.7148, 36.2074], [55.7427, 36.2239], [55.7582, 36.2623], [55.7830, 36.2733],
    [55.8077, 36.3008], [55.8356, 36.3282], [55.8572, 36.3667], [55.8696, 36.3996], [55.8973, 36.4271],
    [55.9282, 36.4436], [55.9559, 36.4381], [55.9806, 36.4546], [56.0083, 36.4930], [56.0360, 36.5040],
    [56.0667, 36.4985], [56.0913, 36.5260], [56.1066, 36.5589], [56.1373, 36.5919], [56.1105, 36.5548]
]


class AreaResolver(object):
    AREA_TTK = 5
    AREA_MKAD = 6
    AREA_MMK = 7
    AREA_BMK = 8

    AREAS = {
        AREA_TTK: TTK,
        AREA_MKAD: MKAD,
        AREA_MMK: MMK,
        AREA_BMK: BMK
    }

    AREAS_ORDER = [AREA_TTK, AREA_MKAD, AREA_MMK, AREA_BMK]

    @classmethod
    def resolve(cls, point, available_areas):
        test_point = Point(point['lat'], point['lng'])
        areas = []
        for area in cls.AREAS_ORDER:
            if area in available_areas:
                areas.append(area)

        for key in areas:
            area = cls.AREAS[key]
            if Polygon(area).contains(test_point):
                return key

        return None
